﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace HotelCalifornia
{
    /// <summary>
    /// Логика взаимодействия для Variant.xaml
    /// </summary>
    public partial class Variant : Window
    {
        public Variant()
        {
            InitializeComponent();
            //Таймер на обновление времени
            DispatcherTimer timer = new DispatcherTimer();
            timer.Tick += new EventHandler(Update_Timer_Tick);
            timer.Interval = new TimeSpan(0, 0, 1);
            timer.Start();
        }

        //Вывод даты и время в textbox
        private void Update_Timer_Tick(object sender, EventArgs e)
        {
            timetxt.Text = DateTime.Now.ToString();
        }

        //Перетаскивание окна
        private void Grid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            DragMove();
        }

        //Выход из приложения
        private void Close(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы хотите выйти из приложения?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            switch (result)
            {
                case MessageBoxResult.Yes:
                    Application.Current.Shutdown();
                    break;
                case MessageBoxResult.No:
                    break;
            }
        }
        
        //Возврат к окну авторизации
        private void Back(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы хотите вернуться к окну авторизации?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            switch (result)
            {
                case MessageBoxResult.Yes:
                    MainWindow mainWindow = new MainWindow();
                    this.Close();
                    mainWindow.Show();
                    break;
                case MessageBoxResult.No:
                    break;
            }
        }

        //Переход к окну клиентов
        private void KlientGO_Click(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы хотите перейти к окну клиентов?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            switch (result)
            {
                case MessageBoxResult.Yes:
                    Client client = new Client();
                    this.Close();
                    client.Show();
                    break;
                case MessageBoxResult.No:
                    break;
            }
        }

        //Переход к окну комнат
        private void RoomGO_Click(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы хотите перейти к окну комнат?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            switch (result)
            {
                case MessageBoxResult.Yes:
                    Room room = new Room();
                    this.Close();
                    room.Show();
                    break;
                case MessageBoxResult.No:
                    break;
            }
        }

        private void WindMin_Click(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
        }

        //Переход к окну работников
        private void StaffGO_Click(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы хотите перейти к окну работников?", "Предупреждение", MessageBoxButton.YesNo, MessageBoxImage.Question);
            switch (result)
            {
                case MessageBoxResult.Yes:
                    Staff staff = new Staff();
                    this.Close();
                    staff.Show();
                    break;
                case MessageBoxResult.No:
                    break;
            }
        }
    }
}
